Index: LMDZ6/trunk/libf/misc/trac_types_mod.F90
===================================================================
--- LMDZ6/trunk/libf/misc/trac_types_mod.F90	(revision 4046)
+++ LMDZ6/trunk/libf/misc/trac_types_mod.F90	(revision 4046)
@@ -0,0 +1,55 @@
+MODULE trac_types_mod
+
+  USE strings_mod, ONLY: maxlen
+  PRIVATE
+
+!=== TRACERS DESCRIPTOR DERIVED TYPE AND ASSOCIATED ROUTINES INTERFACES =======================================================
+  PUBLIC :: trac_type, isot_type, keys_type
+!------------------------------------------------------------------------------------------------------------------------------
+  TYPE :: keys_type                                        !=== TYPE FOR A SET OF KEYS ASSOCIATED TO AN ELEMENT
+    CHARACTER(LEN=maxlen)              :: name             !--- Tracer name
+    CHARACTER(LEN=maxlen), ALLOCATABLE :: key(:)           !--- Keys string list
+    CHARACTER(LEN=maxlen), ALLOCATABLE :: val(:)           !--- Corresponding values string list
+  END TYPE keys_type
+!------------------------------------------------------------------------------------------------------------------------------
+  TYPE :: trac_type                                        !=== TYPE FOR A SINGLE TRACER NAMED "name"
+    CHARACTER(LEN=maxlen) :: name        = ''              !--- Name of the tracer
+    CHARACTER(LEN=maxlen) :: gen0Name    = ''              !--- First generation ancestor name
+    CHARACTER(LEN=maxlen) :: parent      = ''              !--- Parent name
+    CHARACTER(LEN=maxlen) :: longName    = ''              !--- Long name (with advection scheme suffix)
+    CHARACTER(LEN=maxlen) :: type        = 'tracer'        !--- Type  (so far: 'tracer' / 'tag')
+    CHARACTER(LEN=maxlen) :: phase       = 'g'             !--- Phase ('g'as / 'l'iquid / 's'olid)
+    CHARACTER(LEN=maxlen) :: component                     !--- Coma-separated list of components (Ex: lmdz,inca)
+    INTEGER               :: iadv        = 10              !--- Advection scheme used
+    INTEGER               :: iGeneration = 1               !--- Generation number (>=1)
+    LOGICAL               :: isAdvected  = .FALSE.         !--- "true" tracers: iadv > 0 . COUNT(     isAdvected) =nqtrue
+    LOGICAL               :: isH2Ofamily = .FALSE.         !--- H2O tracers/isotopes/tags. COUNT(.NOT.isH2Ofamily)=nqtottr
+    INTEGER               :: iqParent    = 0               !--- Parent index
+    INTEGER,  ALLOCATABLE :: iqDescen(:)                   !--- Descendants index (in growing generation order)
+    INTEGER               :: nqDescen    = 0               !--- Number of descendants (all generations)
+    INTEGER               :: nqChilds    = 0               !--- Number of childs    (first generation)
+    INTEGER               :: iso_iGroup  = 0               !--- Isotopes group index in isotopes(:)
+    INTEGER               :: iso_iName   = 0               !--- Isotope  name  index in isotopes(iso_iGroup)%trac(:)
+    INTEGER               :: iso_iZone   = 0               !--- Isotope  zone  index in isotopes(iso_iGroup)%zone(:)
+    INTEGER               :: iso_iPhase  = 0               !--- Isotope  phase index in isotopes(iso_iGroup)%phas
+    TYPE(keys_type)       :: keys                          !--- <key>=<val> pairs vector
+  END TYPE trac_type
+!------------------------------------------------------------------------------------------------------------------------------
+  TYPE :: isot_type                                        !=== TYPE FOR AN ISOTOPES FAMILY DESCENDING ON TRACER "parent"
+    CHARACTER(LEN=maxlen)              :: parent           !--- Isotopes family name (parent tracer name ; ex: H2O)
+    LOGICAL                            :: check=.FALSE.    !--- Triggering of the checking routines
+    TYPE(keys_type),       ALLOCATABLE :: keys(:)          !--- Isotopes keys/values pairs list     (length: niso)
+    CHARACTER(LEN=maxlen), ALLOCATABLE :: trac(:)          !--- Isotopes + tagging tracers list     (length: nitr)
+    CHARACTER(LEN=maxlen), ALLOCATABLE :: zone(:)          !--- Geographic tagging zones names list (length: nzon)
+    CHARACTER(LEN=maxlen)              :: phase = 'g'      !--- Phases list: [g][l][s]              (length: npha)
+    INTEGER                            :: niso = 0         !--- Number of isotopes, excluding tagging tracers
+    INTEGER                            :: nzon = 0         !--- Number of geographic tagging zones
+    INTEGER                            :: nitr = 0         !--- Number of isotopes, including tagging tracers
+    INTEGER                            :: npha = 0         !--- Number phases
+    INTEGER,               ALLOCATABLE :: iTraPha(:,:)     !--- Idx in "trac(1:niso)" = f(name(1:nitr)),phas)
+                                                           !---        "iTraPha" former name: "iqiso"
+    INTEGER,               ALLOCATABLE :: iZonIso(:,:)     !--- Idx in "trac(1:nitr)" = f(zone, name(1:niso))
+                                                           !---        "iZonIso" former name: "index_trac"
+  END TYPE isot_type
+
+END MODULE trac_types_mod
Index: LMDZ6/trunk/libf/phylmd/Dust/phytracr_spl_mod.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/Dust/phytracr_spl_mod.F90	(revision 4045)
+++ LMDZ6/trunk/libf/phylmd/Dust/phytracr_spl_mod.F90	(revision 4046)
@@ -1416,20 +1416,12 @@
        !print *,nbtr
        do it=1,nbtr
-        print *, it, tname(it+nqo)
-        if (tname(it+nqo) == 'PREC' ) then
-            id_prec=it
-        endif
-        if (tname(it+nqo) == 'FINE' ) then
-            id_fine=it
-        endif
-        if (tname(it+nqo) == 'COSS' ) then
-            id_coss=it
-        endif
-        if (tname(it+nqo) == 'CODU' ) then
-            id_codu=it
-        endif
-        if (tname(it+nqo) == 'SCDU' ) then
-            id_scdu=it
-        endif
+        print *, it, tracers(it+nqo)%name
+        SELECT CASE(tracers(it+nqo)%name)
+          CASE('PREC'); id_prec=it
+          CASE('FINE'); id_fine=it
+          CASE('COSS'); id_coss=it
+          CASE('CODU'); id_codu=it
+          CASE('SCDU'); id_scdu=it
+        END SELECT
        enddo
        ! check consistency with dust emission scheme:
Index: LMDZ6/trunk/libf/phylmd/Dust/splaeropt_5wv_rrtm.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/Dust/splaeropt_5wv_rrtm.F90	(revision 4045)
+++ LMDZ6/trunk/libf/phylmd/Dust/splaeropt_5wv_rrtm.F90	(revision 4046)
@@ -113,26 +113,12 @@
 
   DO itr=1,nbtr    !--loop over tracers  
-
-    IF (tname(itr+nqo)=='PREC') THEN       !--fine mode accumulation mode
-      CYCLE
-    ELSE IF (tname(itr+nqo)=='FINE') THEN  !--fine mode accumulation mode
-      soluble=.TRUE.
-      spsol=1
-      aerindex=1
-    ELSE IF (tname(itr+nqo)=='COSS') THEN  !--coarse mode sea salt
-      soluble=.TRUE.
-      spsol=2
-      aerindex=2
-    ELSE IF (tname(itr+nqo)=='CODU') THEN  !--coarse mode dust
-      soluble=.FALSE.
-      spinsol=1
-      aerindex=3
-    ELSE IF (tname(itr+nqo)=='SCDU') THEN  !--super coarse mode dust
-      soluble=.FALSE.
-      spinsol=2
-      aerindex=4
-    ELSE
-       CALL abort_physic(modname,'I cannot do aerosol optics for '//tname(itr+nqo),1)
-    ENDIF
+    SELECT CASE(tracers(itr+nqo)%name)
+      CASE('PREC'); CYCLE                                  !--precursor
+      CASE('FINE'); soluble=.TRUE.;  spsol=1; aerindex=1   !--fine mode accumulation mode
+      CASE('COSS'); soluble=.TRUE.;  spsol=2; aerindex=2   !--coarse mode sea salt
+      CASE('CODU'); soluble=.FALSE.; spsol=1; aerindex=3   !--coarse mode dust
+      CASE('SCDU'); soluble=.FALSE.; spsol=2; aerindex=4   !--super coarse mode dust
+      CASE DEFAULT; CALL abort_physic(modname,'I cannot do aerosol optics for '//tracers(itr+nqo)%name,1)
+    END SELECT
 
     DO la=1,las
Index: LMDZ6/trunk/libf/phylmd/Dust/splaeropt_6bands_rrtm.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/Dust/splaeropt_6bands_rrtm.F90	(revision 4045)
+++ LMDZ6/trunk/libf/phylmd/Dust/splaeropt_6bands_rrtm.F90	(revision 4046)
@@ -165,27 +165,13 @@
   cg_ae(:,:,:,:)=0.
     
-  DO itr=1, nbtr
-
-    IF (tname(itr+nqo)=='PREC') THEN       !--precursor
-      CYCLE
-    ELSE IF (tname(itr+nqo)=='FINE') THEN  !--fine mode accumulation mode
-      soluble=.TRUE.
-      spsol=1
-      aerindex=1
-    ELSE IF (tname(itr+nqo)=='COSS') THEN  !--coarse mode sea salt
-      soluble=.TRUE.
-      spsol=2
-      aerindex=2
-    ELSE IF (tname(itr+nqo)=='CODU') THEN  !--coarse mode dust
-      soluble=.FALSE.
-      spinsol=1
-      aerindex=3
-    ELSE IF (tname(itr+nqo)=='SCDU') THEN  !--super coarse mode dust
-      soluble=.FALSE.
-      spinsol=2
-      aerindex=4
-    ELSE
-       CALL abort_physic(modname,'I cannot do aerosol optics for '//tname(itr+nqo),1)
-    ENDIF
+  DO itr=1,nbtr    !--loop over tracers  
+    SELECT CASE(tracers(itr+nqo)%name)
+      CASE('PREC'); CYCLE                                  !--precursor
+      CASE('FINE'); soluble=.TRUE.;  spsol=1; aerindex=1   !--fine mode accumulation mode
+      CASE('COSS'); soluble=.TRUE.;  spsol=2; aerindex=2   !--coarse mode sea salt
+      CASE('CODU'); soluble=.FALSE.; spsol=1; aerindex=3   !--coarse mode dust
+      CASE('SCDU'); soluble=.FALSE.; spsol=2; aerindex=4   !--super coarse mode dust
+      CASE DEFAULT; CALL abort_physic(modname,'I cannot do aerosol optics for '//tracers(itr+nqo)%name,1)
+    END SELECT
 
     IF (soluble) THEN ! For aerosol soluble components
Index: LMDZ6/trunk/libf/phylmd/Dust/splaeropt_lw_rrtm.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/Dust/splaeropt_lw_rrtm.F90	(revision 4045)
+++ LMDZ6/trunk/libf/phylmd/Dust/splaeropt_lw_rrtm.F90	(revision 4046)
@@ -55,18 +55,10 @@
     !
     DO itr=1,nbtr
-      !
-      IF (tname(itr+nqo)=='PREC') THEN       !--precursor
-        CYCLE
-      ELSE IF (tname(itr+nqo)=='FINE') THEN  !--fine mode accumulation mode
-        CYCLE
-      ELSE IF (tname(itr+nqo)=='COSS') THEN  !--coarse mode sea salt
-        CYCLE
-      ELSE IF (tname(itr+nqo)=='CODU') THEN  !--coarse mode dust
-        spinsol=1
-      ELSE IF (tname(itr+nqo)=='SCDU') THEN  !--super coarse mode dust
-        spinsol=2
-      ELSE
-         CALL abort_physic(modname,'I cannot do aerosol optics for '//tname(itr+nqo),1)
-      ENDIF
+      SELECT CASE(tracers(itr+nqo)%name)
+        CASE('PREC','FINE''COSS'); CYCLE                   !--precursor or fine/coarde accumulation mode
+        CASE('CODU'); spinsol=1                            !--coarse mode dust
+        CASE('SCDU'); spinsol=2                            !--super coarse mode dust
+        CASE DEFAULT; CALL abort_physic(modname,'I cannot do aerosol optics for '//tracers(itr+nqo)%name,1)
+      END SELECT
       !
       DO inu=1,NLW
Index: LMDZ6/trunk/libf/phylmd/Dust/splaerosol_optic_rrtm.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/Dust/splaerosol_optic_rrtm.F90	(revision 4045)
+++ LMDZ6/trunk/libf/phylmd/Dust/splaerosol_optic_rrtm.F90	(revision 4046)
@@ -51,5 +51,5 @@
   !
   DO itr=1,nbtr
-    IF (tname(itr+nqo)=='FINE') THEN
+    IF (tracers(itr+nqo)%name=='FINE') THEN
       mass_solu_aero(:,:)    = tr_seri(:,:,itr)
       mass_solu_aero_pi(:,:) = tr_seri(:,:,itr)
Index: LMDZ6/trunk/libf/phylmd/cvltr.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/cvltr.F90	(revision 4045)
+++ LMDZ6/trunk/libf/phylmd/cvltr.F90	(revision 4046)
@@ -12,5 +12,5 @@
   USE IOIPSL 
   USE dimphy
-  USE infotrac_phy, ONLY : nbtr,tname
+  USE infotrac_phy, ONLY : nbtr
   IMPLICIT NONE 
 !=====================================================================
Index: LMDZ6/trunk/libf/phylmd/cvltr_scav.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/cvltr_scav.F90	(revision 4045)
+++ LMDZ6/trunk/libf/phylmd/cvltr_scav.F90	(revision 4046)
@@ -13,5 +13,5 @@
   USE IOIPSL 
   USE dimphy
-  USE infotrac_phy, ONLY : nbtr,tname
+  USE infotrac_phy, ONLY : nbtr
   IMPLICIT NONE 
   !=====================================================================
Index: LMDZ6/trunk/libf/phylmd/cvltr_spl.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/cvltr_spl.F90	(revision 4045)
+++ LMDZ6/trunk/libf/phylmd/cvltr_spl.F90	(revision 4046)
@@ -13,5 +13,5 @@
   USE IOIPSL 
   USE dimphy
-  USE infotrac_phy, ONLY : nbtr,tname
+  USE infotrac_phy, ONLY : nbtr
   IMPLICIT NONE 
 !=====================================================================
Index: LMDZ6/trunk/libf/phylmd/dyn1d/1DUTILS.h
===================================================================
--- LMDZ6/trunk/libf/phylmd/dyn1d/1DUTILS.h	(revision 4045)
+++ LMDZ6/trunk/libf/phylmd/dyn1d/1DUTILS.h	(revision 4046)
@@ -713,5 +713,5 @@
 !!      enddo
       DO iq = 1,nqtot
-        nmq(iq) = trim(tname(iq))
+        nmq(iq) = trim(tracers(iq)%name)
       ENDDO
       print*,'in dyn1deta0 ',fichnom,klon,klev,nqtot
@@ -864,5 +864,5 @@
 !!      nmq(4)="tra2"
       DO iq = 1,nqtot
-        nmq(iq) = trim(tname(iq))
+        nmq(iq) = trim(tracers(iq)%name)
       ENDDO
 
Index: LMDZ6/trunk/libf/phylmd/infotrac_phy.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/infotrac_phy.F90	(revision 4045)
+++ LMDZ6/trunk/libf/phylmd/infotrac_phy.F90	(revision 4046)
@@ -7,4 +7,6 @@
 ! the dynamics (could be further cleaned) and is initialized using values
 ! provided by the dynamics
+
+  USE readTracFiles_mod, ONLY: trac_type, maxlen, delPhase
 
 ! nqtot : total number of tracers and higher order of moment, water vapor and liquid included
@@ -41,12 +43,7 @@
 !$OMP THREADPRIVATE(nqperes)
 
-! Name variables
-  INTEGER,PARAMETER :: tname_lenmax=128 
-  CHARACTER(len=tname_lenmax), ALLOCATABLE, DIMENSION(:), SAVE :: tname ! tracer short name for restart and diagnostics
-  CHARACTER(len=tname_lenmax+3), ALLOCATABLE, DIMENSION(:), SAVE :: ttext ! tracer long name for diagnostics
-!$OMP THREADPRIVATE(tname,ttext)
-
-!! iadv  : index of trasport schema for each tracer
-!  INTEGER, ALLOCATABLE, DIMENSION(:), SAVE    :: iadv
+! Tracers parameters
+  TYPE(trac_type), TARGET, ALLOCATABLE, SAVE :: tracers(:)
+!$OMP THREADPRIVATE(tracers)
 
 ! niadv : vector keeping the coorspondance between all tracers(nqtot) treated in the 
@@ -107,5 +104,5 @@
 CONTAINS
 
-  SUBROUTINE init_infotrac_phy(nqtot_,nqo_,nbtr_,nqtottr_,nqCO2_,tname_,ttext_,type_trac_,&
+  SUBROUTINE init_infotrac_phy(nqtot_,nqo_,nbtr_,nqtottr_,nqCO2_,tracers_,type_trac_,&
                                niadv_,conv_flg_,pbl_flg_,solsym_,&
                                nqfils_,nqdesc_,nqdesc_tot_,iqfils_,iqpere_,&
@@ -139,6 +136,5 @@
     INTEGER,INTENT(IN) :: id_BIN01_strat_
 #endif
-    CHARACTER(len=*),INTENT(IN) :: tname_(nqtot_) ! tracer short name for restart and diagnostics
-    CHARACTER(len=*),INTENT(IN) :: ttext_(nqtot_) ! tracer long name for diagnostics
+    TYPE(trac_type), INTENT(IN) :: tracers_(nqtot_) ! tracers descriptors
     CHARACTER(len=*),INTENT(IN) :: type_trac_
     INTEGER,INTENT(IN) :: niadv_ (nqtot_) ! equivalent dyn / physique
@@ -179,4 +175,5 @@
     nqCO2=nqCO2_
     nqtottr=nqtottr_
+    ALLOCATE(tracers(nqtot)); tracers(:) = tracers_(:)
 #ifdef CPP_StratAer
     nbtr_bin=nbtr_bin_
@@ -187,8 +184,4 @@
     id_BIN01_strat=id_BIN01_strat_
 #endif
-    ALLOCATE(tname(nqtot))
-    tname(:) = tname_(:)
-    ALLOCATE(ttext(nqtot))
-    ttext(:) = ttext_(:)
     type_trac = type_trac_
     ALLOCATE(niadv(nqtot))
Index: LMDZ6/trunk/libf/phylmd/iophy.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/iophy.F90	(revision 4045)
+++ LMDZ6/trunk/libf/phylmd/iophy.F90	(revision 4046)
@@ -811,6 +811,6 @@
     IMPLICIT NONE
 
-    CHARACTER(LEN=20)                :: nam_var
-    INTEGER, DIMENSION(nfiles)      :: flag_var
+    CHARACTER(LEN=*), INTENT(INOUT) :: nam_var
+    INTEGER,          INTENT(INOUT) :: flag_var(nfiles)
 
     IF(prt_level>10) WRITE(lunout,*)'Avant getin: nam_var flag_var ',nam_var,flag_var(:)
Index: LMDZ6/trunk/libf/phylmd/phyetat0.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/phyetat0.F90	(revision 4045)
+++ LMDZ6/trunk/libf/phylmd/phyetat0.F90	(revision 4046)
@@ -23,5 +23,5 @@
   USE geometry_mod, ONLY : longitude_deg, latitude_deg
   USE iostart, ONLY : close_startphy, get_field, get_var, open_startphy
-  USE infotrac_phy, only: nbtr, nqo, type_trac, tname, niadv
+  USE infotrac_phy, only: nbtr, nqo, type_trac, tracers, niadv
   USE traclmdz_mod,    ONLY : traclmdz_from_restart
   USE carbon_cycle_mod, ONLY : carbon_cycle_tr, carbon_cycle_cpl, co2_send
@@ -451,6 +451,6 @@
 !!        iiq=niadv(it+2)                                                           ! jyg
         iiq=niadv(it+nqo)                                                           ! jyg
-        found=phyetat0_get(1,trs(:,it),"trs_"//tname(iiq), &
-              "Surf trac"//tname(iiq),0.)
+        found=phyetat0_get(1,trs(:,it),"trs_"//TRIM(tracers(iiq)%name), &
+                                  "Surf trac"//TRIM(tracers(iiq)%name),0.)
      ENDDO
      CALL traclmdz_from_restart(trs)
Index: LMDZ6/trunk/libf/phylmd/phyredem.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/phyredem.F90	(revision 4045)
+++ LMDZ6/trunk/libf/phylmd/phyredem.F90	(revision 4046)
@@ -35,5 +35,5 @@
   USE iostart, ONLY: open_restartphy, close_restartphy, enddef_restartphy, put_field, put_var
   USE traclmdz_mod, ONLY : traclmdz_to_restart
-  USE infotrac_phy, ONLY: type_trac, niadv, tname, nbtr, nqo
+  USE infotrac_phy, ONLY: type_trac, niadv, tracers, nbtr, nqo
   USE carbon_cycle_mod, ONLY : carbon_cycle_cpl, co2_send
   USE indice_sol_mod, ONLY: nbsrf, is_oce, is_sic, is_ter, is_lic, epsfra
@@ -329,5 +329,5 @@
 !!        iiq=niadv(it+2)                                                           ! jyg
           iiq=niadv(it+nqo)                                                           ! jyg
-          CALL put_field(pass,"trs_"//tname(iiq), "", trs(:, it))
+          CALL put_field(pass,"trs_"//tracers(iiq)%name, "", trs(:, it))
        END DO
     END IF
@@ -380,5 +380,5 @@
     IF (pass==1) CALL enddef_restartphy
     IF (pass==2) CALL close_restartphy
- ENDDO
+  ENDDO ! DO pass=1,2   ! pass=1 netcdf definition ; pass=2 netcdf write
   
   !$OMP BARRIER
Index: LMDZ6/trunk/libf/phylmd/phys_output_mod.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/phys_output_mod.F90	(revision 4045)
+++ LMDZ6/trunk/libf/phylmd/phys_output_mod.F90	(revision 4046)
@@ -35,5 +35,6 @@
     USE iophy 
     USE dimphy
-    USE infotrac_phy, ONLY: nqtot, nqo, niadv, tname, ttext, type_trac
+    USE infotrac_phy, ONLY: nqtot, nqo, niadv, tracers, type_trac
+    USE strings_mod,  ONLY: maxlen
     USE ioipsl
     USE phys_cal_mod, only : hour, calend
@@ -95,5 +96,5 @@
     CHARACTER(LEN=4), DIMENSION(nlevSTD)  :: clevSTD
     REAL, DIMENSION(nlevSTD)              :: rlevSTD
-    INTEGER                               :: nsrf, k, iq, iiq, iff, i, j, ilev
+    INTEGER                               :: nsrf, k, iq, iiq, iff, i, j, ilev, jq
     INTEGER                               :: naero
     LOGICAL                               :: ok_veget
@@ -113,4 +114,9 @@
     LOGICAL, DIMENSION(nfiles)            :: phys_out_filekeys
     LOGICAL, DIMENSION(nfiles)            :: phys_out_filestations
+
+    CHARACTER(LEN=50) :: outiso
+    CHARACTER(LEN=20) :: unit
+    CHARACTER(LEN=maxlen) :: tnam, lnam, dn
+    INTEGER :: flag(nfiles)
 
 !!!!!!!!!! stockage dans une region limitee pour chaque fichier !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
@@ -494,85 +500,39 @@
        IF (nqtot>=nqo+1) THEN
 !
-            DO iq=nqo+1,nqtot 
-            iiq=niadv(iq)
-            o_trac(iq-nqo) = ctrl_out((/ 1, 5, 5, 5, 10, 10, 11, 11, 11, 11 /), &
-                           tname(iiq),'Tracer '//ttext(iiq), "-",  &
-                           (/ '', '', '', '', '', '', '', '', '', '' /))
-            o_dtr_vdf(iq-nqo) = ctrl_out((/ 4, 7, 7, 7, 10, 10, 11, 11, 11, 11 /), &
-                              'd'//trim(tname(iq))//'_vdf',  &
-                              'Tendance tracer '//ttext(iiq), "-" , &
-                              (/ '', '', '', '', '', '', '', '', '', '' /))
-
-            o_dtr_the(iq-nqo) = ctrl_out((/ 5, 7, 7, 7, 10, 10, 11, 11, 11, 11 /), &
-                              'd'//trim(tname(iq))//'_the', &
-                              'Tendance tracer '//ttext(iiq), "-", &
-                              (/ '', '', '', '', '', '', '', '', '', '' /))
-
-            o_dtr_con(iq-nqo) = ctrl_out((/ 5, 7, 7, 7, 10, 10, 11, 11, 11, 11 /), &
-                              'd'//trim(tname(iq))//'_con', &
-                              'Tendance tracer '//ttext(iiq), "-", &
-                              (/ '', '', '', '', '', '', '', '', '', '' /))
-
-            o_dtr_lessi_impa(iq-nqo) = ctrl_out((/ 7, 7, 7, 7, 10, 10, 11, 11, 11, 11 /), &
-                                     'd'//trim(tname(iq))//'_lessi_impa', &
-                                     'Tendance tracer '//ttext(iiq), "-", &
-                                     (/ '', '', '', '', '', '', '', '', '', '' /))
-
-            o_dtr_lessi_nucl(iq-nqo) = ctrl_out((/ 7, 7, 7, 7, 10, 10, 11, 11, 11, 11 /), &
-                                     'd'//trim(tname(iq))//'_lessi_nucl', &
-                                     'Tendance tracer '//ttext(iiq), "-", &
-                                     (/ '', '', '', '', '', '', '', '', '', '' /))
-
-            o_dtr_insc(iq-nqo) = ctrl_out((/ 7, 7, 7, 7, 10, 10, 11, 11, 11, 11 /), &
-                               'd'//trim(tname(iq))//'_insc', &
-                               'Tendance tracer '//ttext(iiq), "-", &
-                               (/ '', '', '', '', '', '', '', '', '', '' /))
-
-            o_dtr_bcscav(iq-nqo) = ctrl_out((/ 7, 7, 7, 7, 10, 10, 11, 11, 11, 11 /), &
-                                 'd'//trim(tname(iq))//'_bcscav', &
-                                 'Tendance tracer '//ttext(iiq), "-", &
-                                 (/ '', '', '', '', '', '', '', '', '', '' /))
-
-            o_dtr_evapls(iq-nqo) = ctrl_out((/ 7, 7, 7, 7, 10, 10, 11, 11, 11, 11 /), &
-                                 'd'//trim(tname(iq))//'_evapls', &
-                                 'Tendance tracer '//ttext(iiq), "-", &
-                                 (/ '', '', '', '', '', '', '', '', '', '' /))
-
-            o_dtr_ls(iq-nqo) = ctrl_out((/ 7, 7, 7, 7, 10, 10, 11, 11, 11, 11 /), &
-                             'd'//trim(tname(iq))//'_ls', &
-                             'Tendance tracer '//ttext(iiq), "-", &
-                             (/ '', '', '', '', '', '', '', '', '', '' /))
-
-            o_dtr_trsp(iq-nqo) = ctrl_out((/ 7, 7, 7, 7, 10, 10, 11, 11, 11, 11 /), &
-                               'd'//trim(tname(iq))//'_trsp', &
-                               'Tendance tracer '//ttext(iiq), "-", &
-                               (/ '', '', '', '', '', '', '', '', '', '' /))
-
-            o_dtr_sscav(iq-nqo) = ctrl_out((/ 7, 7, 7, 7, 10, 10, 11, 11, 11, 11 /), &
-                                'd'//trim(tname(iq))//'_sscav', &
-                                'Tendance tracer '//ttext(iiq), "-", &
-                                (/ '', '', '', '', '', '', '', '', '', '' /))
-
-            o_dtr_sat(iq-nqo) = ctrl_out((/ 7, 7, 7, 7, 10, 10, 11, 11, 11, 11 /), &
-                               'd'//trim(tname(iq))//'_sat', &
-                               'Tendance tracer '//ttext(iiq), "-", &
-                               (/ '', '', '', '', '', '', '', '', '', '' /))
-
-            o_dtr_uscav(iq-nqo) = ctrl_out((/ 7, 7, 7, 7, 10, 10, 11, 11, 11, 11 /), &
-                                'd'//trim(tname(iq))//'_uscav', &
-                                'Tendance tracer '//ttext(iiq), "-", &
-                                 (/ '', '', '', '', '', '', '', '', '', '' /))
-
-            o_dtr_dry(iq-nqo) = ctrl_out((/ 7, 7, 7, 7, 10, 10, 11, 11, 11, 11 /), &
-                              'cum'//'d'//trim(tname(iq))//'_dry', &
-                              'tracer tendency dry deposition'//ttext(iiq), "-", &
-                              (/ '', '', '', '', '', '', '', '', '', '' /))
-
-            o_trac_cum(iq-nqo) = ctrl_out((/ 1, 4, 10, 10, 10, 10, 11, 11, 11, 11 /), &
-                               'cum'//tname(iiq),&
-                               'Cumulated tracer '//ttext(iiq), "-", &
-                               (/ '', '', '', '', '', '', '', '', '', '' /))
-            ENDDO
-      ENDIF
+          DO iq=nqo+1,nqtot 
+            iiq=niadv(iq); jq = iq-nqo
+            dn = 'd'//TRIM(tracers(iiq)%name)//'_'
+
+            flag = [1, 5, 5, 5, 10, 10, 11, 11, 11, 11]
+            lnam = 'Tracer '//TRIM(tracers(iiq)%longName)
+            tnam = TRIM(tracers(iiq)%name); o_trac          (jq) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+            flag = [4, 7, 7, 7, 10, 10, 11, 11, 11, 11]
+            lnam = 'Tendance tracer '//TRIM(tracers(iiq)%longName)
+            tnam = TRIM(dn)//'vdf';         o_dtr_vdf       (jq) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+
+            flag = [5, 7, 7, 7, 10, 10, 11, 11, 11, 11]
+            tnam = TRIM(dn)//'the';         o_dtr_the       (jq) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+            tnam = TRIM(dn)//'con';         o_dtr_con       (jq) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+
+            flag = [7, 7, 7, 7, 10, 10, 11, 11, 11, 11]
+            tnam = TRIM(dn)//'lessi_impa';  o_dtr_lessi_impa(jq) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+            tnam = TRIM(dn)//'lessi_nucl';  o_dtr_lessi_nucl(jq) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+            tnam = TRIM(dn)//'insc';        o_dtr_insc      (jq) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+            tnam = TRIM(dn)//'bcscav';      o_dtr_bcscav    (jq) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+            tnam = TRIM(dn)//'evapls';      o_dtr_evapls    (jq) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+            tnam = TRIM(dn)//'ls';          o_dtr_ls        (jq) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+            tnam = TRIM(dn)//'trsp';        o_dtr_trsp      (jq) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+            tnam = TRIM(dn)//'sscav';       o_dtr_sscav     (jq) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+            tnam = TRIM(dn)//'sat';         o_dtr_sat       (jq) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+            tnam = TRIM(dn)//'uscav';       o_dtr_uscav     (jq) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+
+            lnam = 'tracer tendency dry deposition'//TRIM(tracers(iiq)%longName)
+            tnam = 'cum'//TRIM(dn)//'dry';  o_dtr_dry       (jq) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+
+            flag = [1, 4, 10, 10, 10, 10, 11, 11, 11, 11]
+            lnam = 'Cumulated tracer '//TRIM(tracers(iiq)%longName)
+            tnam = 'cum'//TRIM(tracers(iiq)%name); o_trac_cum(jq)= ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+          ENDDO
+       ENDIF
 
    ENDDO !  iff
@@ -594,4 +554,12 @@
       WRITE(lunout,*)'phys_output_open: ends here'
     ENDIF
+
+!  DO iq=nqo+1,nqtot 
+!    iiq=niadv(iq)
+!    dn = 'd'//TRIM(tracers(iiq)%name)//'_'
+!    WRITE(*,'(a,i1,a,10i3)')'trac(',iiq,')%flag = ',o_trac(iiq)%flag
+!    WRITE(*,'(a,i1,a)')'trac(',iiq,')%tnam = '//TRIM(o_trac(iiq)%name)
+!    WRITE(*,'(a,i1,a)')'trac(',iiq,')%lnam = '//TRIM(o_trac(iiq)%description)
+!  END DO
 
   END SUBROUTINE phys_output_open
Index: LMDZ6/trunk/libf/phylmd/phys_output_var_mod.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/phys_output_var_mod.F90	(revision 4045)
+++ LMDZ6/trunk/libf/phylmd/phys_output_var_mod.F90	(revision 4046)
@@ -5,4 +5,5 @@
 
   USE dimphy
+  USE strings_mod, ONLY: maxlen
   ! Variables outputs pour les ecritures des sorties
   !======================================================================
@@ -121,9 +122,9 @@
 
   TYPE ctrl_out
-     INTEGER,DIMENSION(nfiles)            :: flag
-     CHARACTER(len=20)                    :: name
-     CHARACTER(len=150)                   :: description
-     CHARACTER(len=20)                    :: unit
-     CHARACTER(len=20),DIMENSION(nfiles)  :: type_ecrit
+     INTEGER               :: flag(nfiles)
+     CHARACTER(len=maxlen) :: name
+     CHARACTER(len=maxlen) :: description
+     CHARACTER(len=maxlen) :: unit
+     CHARACTER(len=maxlen) :: type_ecrit(nfiles)
   END TYPE ctrl_out
 
